﻿<template>
    <v-app>
        <v-form ref="form"
                v-model="valid"
                lazy-validation>
            <v-row>
                <v-col cols="12">
                    <v-text-field v-model="userName"
                                  readonly
                                  label="Username"></v-text-field>
                </v-col>
                <v-col cols="12">
                    <v-text-field v-model="companyName"
                                  :rules="companyNameRules"
                                  label="Company name"
                                  required></v-text-field>
                </v-col>
                <v-spacer></v-spacer>
                <v-col class="d-flex" cols="12" sm="3" xsm="12" align-end>
                    <v-btn :disabled="!valid"
                           color="success"
                           class="mr-4"
                           @click="onClientCreate">
                        Отправить
                    </v-btn>
                </v-col>
            </v-row>
        </v-form>
    </v-app>
</template>

<script>
    import { mapActions, mapGetters } from 'vuex'

    export default {
        data() {
            return {
                valid: true,
                isEdit: false,
                id: 0,
                userId: 0,
                userName: '',
                companyName: '',
                companyNameRules: [
                    v => !!v || 'Поле имя компании не должен быть пустым',
                ],
            }
        },
        created() {
            this.onClientData();
            this.onUserPersonalData();
        },
        computed: {
            ...mapGetters('user', ['getUserPersonalData']),
            ...mapGetters('client', ['getClientData']),
        },
        methods: {
            ...mapActions('user', ['onUserPersonalData']),
            ...mapActions('client', ['onClientData']),
            validate() {
                this.$refs.form.validate()
            },
            async onClientCreate() {
                await this.validate()
                if (this.valid) {
                    let companyName = this.companyName;
                    let userId = this.userId;
                    let id = this.id;
                    let dispatchPath = this.isEdit ? 'client/clientEdit' : 'client/clientCreate';
                    let data = this.isEdit ? {
                        companyName,
                        id
                    } : {
                            userId,
                            companyName
                        }
                    this.$store
                        .dispatch(dispatchPath,
                            data
                        )
                        .then(() => {
                            this.$router.push({ name: 'Home' })
                        })
                        .catch(err => {
                            if (err) {
                                this.companyName = '';
                                this.companyNameRules = [
                                    v => !!v || 'Поле имя компании не должен быть пустым'
                                ];
                            }
                        })
                } else return
            }
        },
        watch: {
            getUserPersonalData() {
                if (this.getUserPersonalData != undefined) {
                    this.userId = this.getUserPersonalData.id;
                    this.userName = this.getUserPersonalData.userName;
                }
            },
            getClientData() {
                if (this.getClientData != undefined) {
                    this.isEdit = this.getClientData.length > 0;
                    if (this.isEdit) {
                        this.id = this.getClientData.id;
                    }
                }
            }
        }
    }
</script>